# Набор специфичных AT-команд для разных типов модемов Huawei (GSM-модемы)

С современныеми USB-модемами намного проще работать через API. При подключении к компьютеры
они предоставляют http-интерфейс, и даже если у вас нет описания API, в разы проще посмотреть
какие WEB-формы дёргают через интенфейс, и приспособить свое приложение на такое же поведение.

Но если у можема нет API, или хочется похаркодить, то эта инструкция в помощь.

|                                                                            |
|:---------------------------------------------------------------------------|
| Для отправления AT-команд рекомендуется использовать Huawei modem terminal |

## Команды управления «режимами накопителя» модемов Huawei

* Девайс в режиме «только модем» -- `AT^U2DIAG=0`
* Девайс в режиме «модем + CD-ROM» -- `AT^U2DIAG=1`
* Девайс в режиме «модем + CD-ROM + Card Reader» -- `AT^U2DIAG=255` (не поддерживается для __Huawei E1750__)
    *  Если модем не принимает команду `AT^U2DIAG=255`, тогда вводим `AT^U2DIAG=1`
* девайс в режиме «модем + Card Reader» -- `AT^U2DIAG=256`
* Отображение списка всех устройств в модеме -- `AT^GETPORTMODE`

 
## Наиболее часто используемые at команды при работе с модемом huawei:

* `ATI` — вывод информации о модеме
* `AT+CFUN=1` – перезагрузка модема, очень полезная команда не требует «передергивать» модем. После перезагрузки модем перерегистрируется в сети оператора.
* `AT+CGMI` — информация о производителе модема _(Recieve: huawei)_
* `AT+CGMR` — информация о версии прошивки _(Recieve: 11.608.12.04.21)_
* `AT+CIMI` — информация об IMSI номер SIM карты _(Recieve: 250015800471114)_
* `AT+CGSN` — информация о IMEI модема _(Recieve: 353142033840706)_
* `AT^HWVER` — информация о версии железа модема _(Recieve: ^HWVER:"CD6ATCPU")_
* `AT+CSQ` — посмотреть уровень радиосигнала
* 'AT^CMDL' — получить список всех комманд
* `AT+CGMM` или `AT+GMM` — запросить название модели
* `AT+COPS` — информация о текущем операторе _(Recieve: +COPS: (1,"MTS-RUS","MTS","25001",0),(2,"MTS-RUS","MTS","25001",2),,(0,1,2,3,4),(0,1,2))_
* `AT^U2DIAG?` — текущий режим.
* `AT^GETPORTMODE` – список всех устройств в модеме
* `AT+CLAC` в ответе будет список поддерживаемых команд

## Включение голосовых функций модема:

* `AT^CVOICE=?` – проверка состояния голосовых функций модема (0 — значит включено)
* `AT^CVOICE=0` – включение голосовых функций модема

## Включение / отключение режимов 2G и 3G:

* `AT^SYSCFG=13,1,3fffffff,0,0` – режим только 2G
* `AT^SYSCFG=2,1,3fffffff,0,0` – режим предпочтительно 2G
* `AT^SYSCFG=14,2,3fffffff,0,1` – режим только 3G
* `AT^SYSCFG=2,2,3fffffff,0,1` – режим предпочтительно 3G
* `AT^SYSCFG=2,2,3fffff ff,0,2` – режим включение 2G и 3G

## Включение / отключение режимов WCDMA, HSDPA, HSPA+, HSPA:

* `AT^HSDPA=1` – режим HSDPA включен
* `AT^HSDPA=0` – режим HSDPA выключен
* `AT^HSUPA=1` – режим HSUPA включен
* `AT^HSUPA=0` – режим HSUPA выключен
* `AT^HSPA=0` – режим WCDMA
* `AT^HSPA=1` – режим HSDPA
* `AT^HSPA=2` – режим HSPA
* `AT^HSPA=3` – режим HSPA+
* `AT^SYSCFG=13,1,3FFFFFFF,2,4` – режим только GPRS/EDGE
* `AT^SYSCFG=14,2,3FFFFFFF,2,4` – режим только 3G/WCDMA
* `AT^SYSCFG=2,1,3FFFFFFF,2,4` – режим предпочтительно GPRS/EDGE
* `AT^SYSCFG=2,2,3FFFFFFF,2,4` – режим предпочтительно 3G/WCDMA

## Команды необходимые для разблокировки модема (разлочка модема)

* `AT^CARDLOCK="NCK Code"` – ввод кода снятия блокировки (8-значное число)
* `AT^CARDUNLOCK="MD5 NCK Code"` – сброс попыток ввода кода NCK кода разблокировки до 10 раз
* `AT^CARDLOCK?` – проверка состояния блокировки модема и количества попыток ввода кода разблокировки: (ответ модема: _CARDLOCK: A,B,0_ , если __A=2__ модем разблокирован, __A=1__ модем заблокирован – SimLock, если __A=3__ здесь два варианта либо вы израсходовали все 10 попыток ввести код, либо у вас в модеме кастомизированная прошивка; __B__ – количество оставшихся попыток ввода кода разблокировки (по умолчанию 10 раз))

## Изменение режима модема

* `AT^U2DIAG=Команда` — для изменения режим модема (Модем,CD ROM, Флешка, PC UI, NDIS, Смарткарта).

### AT-команды для модемов Huawei E171.

* `AT^SETPORT="A1,A2,1,2,3,7,A1,A2"` -- Установить конфигурацию по умолчанию
* `AT^SETPORT="A1,A2,1,2,3,7"` -- девайс в режиме «модем + сетевая карта»
* `AT^SETPORT="A1,A2;1,2,3,A2"` -- девайс в режиме «модем + Card Reader»
* `AT^SETPORT="A1,A2;1,2,3"` -- девайс в режиме «только модем»
* `AT^SETPORT="A1,2,7"` -- девайс в режиме «сетевая карта + CD-ROM»
* `AT^SETPORT="A1,A2,2,7"` -- девайс в режиме «сетевая карта» — для Windows 7
* `AT^SETPORT="A1;1,2"` -- девайс в режиме «модем + пользовательский интерфейс»
* `AT^SETPORT?` -- Текущая конфигурация модема
* `AT^GETPORTMODE` -- Отображение текущего активного режима
* `AT^SETPORT="A1,A2,1,2,3,7,A1,A2,4,5,6,A,B,D,E"` -- Сброс настроек по умолчанию

## Настройки режимов сети по умолчанию для _Huawei E352_

* `at^hspa?`
* `^HSPA: 2`
* `AT^SETPORT?`
* `A1,A2;1,2,3,7,A1,A2`
* `AT^SYSCFG?`
* `^SYSCFG:2,2,3FFFFFFF,1,2`

## Настройки режимов сети по умолчанию для _Huawei E352b (21.158.23.00.209)_

* `AT^SETPORT?`
* `A1,A2;1,16,3,2,A1,A2`

AT-команды для модема Huawei E1750

## АТ команды переключения режимов huawei E1750

* `AT^U2DIAG=0` -- девайс в режиме только модем
* `AT^U2DIAG=1` -- девайс в режиме модем + CD-ROM
* `AT^U2DIAG=6` -- девайс в режиме только сетевая карта)
* `AT^U2DIAG=268` -- для _E1750_ девайс в режиме модем + CD-ROM + Card Reader
* `AT^U2DIAG=276` -- для _E1750_ девайс в режиме сетевой карты + CD-ROM + Card Reader
* `AT^U2DIAG=256` -- девайс в режиме модем + Card Reader, можно использовать как обычную флешку, отказавшись от установки драйверов модема

## АТ команды переключения режимов сети huawei E1750

* `AT^SYSCFG=14,2,3fffffff,1,2` -- Только 3G
* `AT^SYSCFG=13,1,3fffffff,1,2` -- Только GSM
* `AT^SYSCFG=2,2,3fffffff,1,2` -- Приоритет 3G

## AT-команды переключения режимов сети для модема Huawei E1820 (E182E)

* `AT^SYSCFG=13,2,3fffffff,1,2` — только GSM
* `AT^SYSCFG=2,1,3fffffff,1,2` — преимущественно GSM
* `AT^SYSCFG=14,2,3fffffff,1,2` — только WCDMA
* `AT^SYSCFG=2,2,3fffffff,1,2` — преимущественно WCDMA

## AT-команды для модема Huawei E3131

* `AT^SETPORT="A1,A2;1,16,3,2,A1,A2"` — Установить конфигурацию по умолчанию
* `AT^SETPORT="A1,A2;1,2,3,16,A1,A2"` — режим для работы модема с Android 4.0 (иногда работает)
* `AT^SETPORT="A1,A2;1,16,3,2"` — девайс в режиме «модем + сетевая карта»
* `AT^SETPORT="A1,A2;1,3,2,A2"` — девайс в режиме «модем + Card Reader»
* `AT^SETPORT="A1,A2;1,3,2"` — девайс в режиме «только модем»
* `AT^SETPORT="A1,A2;2,16"` — девайс в режиме «сетевая карта»
* `AT^SETPORT="A1,A2;2,16,A1"` — девайс в режиме «сетевая карта + CD-ROM»

## AT команды для модема Huawei E303 HiLink

* `AT^U2DIAG=374` -- Перевод модема из режима Hilink в режим com портов
* `AT^U2DIAG=375` -- Возврат в исходный режим

## AT команды для модема Huawei E3276

* `AT^SETPORT="A1;10,12,13,14,16,A1,A2"` — Включает все COM порты.
* `AT^SETPORT="A1,A2;12,16,A1,A2"` — Установка по умолчанию.

## AT команды для преключения режимов в модемах huawei с LTE (E392, E398)

Если для USB-модема вы хотите включить режим только LTE, отключив все остальные, необходимо воспользоваться AT командой:

* `AT^SYSCFGEX="03",3fffffff,2,4,7fffffffffffffff,,`
   * В указанной команде первое значение расшифровывается так:
      * 00 — Автоматический режим, установлен по умолчанию (приоритеты в порядке очереди: 4G > 3G > 2G)
      * 01 — GSM GPRS(2G)
      * 02 — WCDMA(3G)
      * 03 — LTE(4G)
      * 99 — Оставить текущие настройки без изменений.
 
 Вы можете также выбрать порядок их приоритета, в порядке убывания, например:

`AT^SYSCFGEX="0302",3fffffff,2,4,7fffffffffffffff,,`
 
В этом случае модем будет пытаться подключиться сначала к сети LTE и потом к сети 3G, кроме работы в сетях 2G.

или такой вариант:

`AT^SYSCFGEX="030201",3fffffff,2,4,7fffffffffffffff,,`

это равносильно

`AT^SYSCFGEX="00",3fffffff,2,4,7fffffffffffffff,,`

Соответственно автоматический режим, установлен по умолчанию (приоритеты в порядке очереди: 4G > 3G > 2G)